/*
    formulesPlugin

    Copyright (c) 2009 by Belov Nikita <null@deltaz.ru>

 ***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************
*/

#include "formules.h"

bool formulesPlugin::init(PluginSystemInterface *plugin_system)
{
	PluginInterface::init(plugin_system);
	m_plugin_system = plugin_system;

	m_str = "<a id='itexNUMBERsTIME' href=\"javascript: document.getElementById('itexNUMBERsTIME').style.display='none'; document.getElementById('atexNUMBERsTIME').style.display='';\" style=\"display: none;\"><img title=\"TEXSTR\" src=\"http://www.sitmo.com/gg/latex/latex2png.2.php?z=SCALE&eq=TEXPERCENT\" onload=\"javascript: document.getElementById('texNUMBERsTIME').style.display='none'; document.getElementById('itexNUMBERsTIME').style.display='';\"/></a><a id='atexNUMBERsTIME' href=\"javascript: document.getElementById('itexNUMBERsTIME').style.display=''; document.getElementById('atexNUMBERsTIME').style.display='none';\" style=\"display: none;\">OPEN1TEXSTROPEN2</a><span id='texNUMBERsTIME'>OPEN1TEXSTROPEN2</span>";
	m_icon = new QIcon();
	m_count = 0;

	m_new_my_message_1 = emit m_plugin_system->registerEventHandler("Core/ChatWindow/SendLevel1.5", this);
	m_new_message = emit m_plugin_system->registerEventHandler("Core/ChatWindow/ReceiveLevel3", this);

	return true;
}

void formulesPlugin::processEvent(Event &event)
{
	if(event.args.size()<1)
		return;

	if(event.id == m_new_my_message_1 || event.id == m_new_message)
	{
		QString *msg = (QString *)event.args.at(1);

		QRegExp rx;
		rx.setMinimal(true);
		int pos;

		rx.setPattern("\\[tex\\](.*)\\[/tex\\]");
		pos = 0;
		while (pos >= 0)
		{
			pos = rx.indexIn(*msg, pos);
			if (pos >= 0)
			{
				pos++;
				itemfound(msg, rx.cap(1), 1);
			}
		}

		rx.setPattern("\\$\\$(.*)\\$\\$");
		pos = 0;
		while (pos >= 0)
		{
			pos = rx.indexIn(*msg, pos);
			if (pos >= 0)
			{
				pos++;
				itemfound(msg, rx.cap(1), 2);
			}
		}
	}

}

void formulesPlugin::itemfound(QString *msg, const QString &str, int type)
{
	QString smsg, pmsg;
	QString rmsg = str;
	QString mesg = m_str;

	rmsg.replace(QRegExp("<img.*title=\"(.*)\".*>"), "\\1");
	rmsg.replace("<br/>", " ");
	rmsg.replace("&lt;", "<");
	rmsg.replace("&gt;", ">");
	rmsg.replace("&amp;", "&");

	smsg = rmsg;
	pmsg = rmsg;

	pmsg = QUrl::toPercentEncoding(pmsg);

	uint id = QDateTime::currentDateTime().toTime_t();

	mesg.replace("NUMBER", QString::number(id));
	mesg.replace("TIME", QString::number(m_count));
	mesg.replace("TEXSTR", smsg);
	mesg.replace("TEXPERCENT", pmsg);
	mesg.replace("SCALE", QString::number(m_scale));

	switch(m_type)
	{
		case 1:
			mesg.replace("OPEN1", "&#36;&#36;");
			mesg.replace("OPEN2", "&#36;&#36;");
			break;
		case 0:
		default:
			mesg.replace("OPEN1", "&#91;tex&#93;");
			mesg.replace("OPEN2", "&#91;/tex&#93;");
			break;
	}

	switch(type)
	{
		case 2:
			msg->replace("$$"+str+"$$", mesg);
			break;
		case 1:
		default:
			msg->replace("[tex]"+str+"[/tex]", mesg);
			break;
	}

	m_count++;
}

void formulesPlugin::setProfileName(const QString &profile_name)
{
	m_profile_name = profile_name;
	loadsettings();
}

QString formulesPlugin::name()
{
	return "Tex formules";
}

QString formulesPlugin::description()
{
	return "Views tex formules";
}

QIcon *formulesPlugin::icon()
{
	return m_icon;
}

QString formulesPlugin::type()
{
	return "view";
}

void formulesPlugin::loadsettings()
{
	QSettings settings(QSettings::defaultFormat(),QSettings::UserScope, "qutim/qutim."+m_profile_name, "formulesPlugin");
	m_scale = settings.value("main/scale", 125).toInt();
	m_type = settings.value("main/type", 0).toInt();
}

void formulesPlugin::saveSettings()
{
	m_settings_widget->saveSettings();
	loadsettings();
}

QWidget *formulesPlugin::settingsWidget()
{
	m_settings_widget = new formulesSettings(m_profile_name);
	return m_settings_widget;
}

void formulesPlugin::removeSettingsWidget()
{
	delete m_settings_widget;
}

Q_EXPORT_PLUGIN2(formulesPlugin, formulesPlugin);
