/*
    formulesPlugin

    Copyright (c) 2009 by Belov Nikita <null@deltaz.ru>

 ***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************
*/


#ifndef formulesPLUGIN_H
#define formulesPLUGIN_H

#include "qutim/plugininterface.h"
#include "formulesSettings.h"

#include <QUrl>
#include <QDebug>

using namespace qutim_sdk_0_2;

class formulesPlugin : public QObject, SimplePluginInterface, EventHandler
{
	Q_OBJECT
	Q_INTERFACES(qutim_sdk_0_2::PluginInterface)

public:
	virtual bool init(PluginSystemInterface *plugin_system);
	virtual void release() {}
	virtual void processEvent(Event &event);
	virtual void setProfileName(const QString &profile_name);
	virtual QString name();
	virtual QString description();
	virtual QString type();
	virtual QIcon *icon();
	virtual QWidget *settingsWidget();
	virtual void saveSettings();

private slots:
	virtual void removeSettingsWidget();

private:
	void loadsettings();
	void itemfound(QString *msg, const QString &str, int type);

	PluginSystemInterface *m_plugin_system;
	QString m_profile_name;
	QString m_account_name;
	formulesSettings *m_settings_widget;

	QIcon *m_icon;
	int m_scale;
	int m_type;

	uint m_count;

	quint16 m_new_my_message_1;
	quint16 m_new_message;

	QString m_str;
};
#endif
