/*
    formulesSettings.cpp

    Copyright (c) 2009 by Nikita 'Δz' Belov <null@deltaz.ru>

 ***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************
*/

#include "formulesSettings.h"

formulesSettings::formulesSettings(QString profileName) : m_profile_name(profileName)
{
	ui.setupUi(this);

	QSettings settings(QSettings::defaultFormat(),QSettings::UserScope, "qutim/qutim."+m_profile_name, "formulesPlugin");
	ui.scaleBox->setValue(settings.value("main/scale", 125).toInt());
	ui.typeBox->setCurrentIndex(settings.value("main/type", 0).toInt());
}

formulesSettings::~formulesSettings()
{
}

void formulesSettings::saveSettings()
{
	QSettings settings(QSettings::defaultFormat(),QSettings::UserScope, "qutim/qutim."+m_profile_name, "formulesPlugin");
	settings.setValue("main/scale", ui.scaleBox->value());
	settings.setValue("main/type", ui.typeBox->currentIndex());
}
